/*
 * Defines a Geometry node.
 * Inherits from Transformable.
 */

#ifndef __RC_GEOMETRY_H__
#define __RC_GEOMETRY_H__

class Geometry : public Transformable {

/*----------------------------------------------------------[ Functions ]----*/

	protected:
		Geometry(
				const char		*nname,
				NodeType_t		ntype
			);
		~Geometry();

	public:

		/*
		 * Lights can be assigned to interact in with the shader that the sub-
		 * classes may implement
		 */
		void setLight(
				Light					*nlight,
				u32						slot
			);

		void clearLight(
				u32						slot
			);

		Light *getLight(
				u32						slot
			);


	protected:

		/* Remove the light refernce due to it being deleted */
		void dereferenceLight(
				Light					*nlight
			);

/*------------------------------------------------------------[ Members ]----*/

	protected:
		Light							*light[MAX_SHADER_LIGHT_SLOTS];

};


#endif /* __RC_GEOMETRY_H__ */

