#include "RenderChimp.h"
#include "SceneGraph.h"
#include "Material.h"
#include "MaterialColorful.h"

/* Shader prefix */
static const char *prefix = \
	"\n"
;

/* Shaders */
static const char *vshader = "../shaders/Material.vs";

static const char *fshader = "../shaders/Material.fs";


/*---------------------------------------------------------------------------*/

MaterialColorful::MaterialColorful(
		const char		*nidentifier,
		u32				purge_level
	) : Material(nidentifier, purge_level, MATERIAL_COLORFUL)
{
	shaderProgram = sceneGraph.createShaderProgram(nidentifier, (char *) prefix,
		"../shaders/MaterialColorful.vs", "../shaders/MaterialColorful.fs", purge_level);

	materialType = MATERIAL_COLORFUL;
}

/*---------------------------------------------------------------------------*/

MaterialColorful::~MaterialColorful()
{
}

/*---------------------------------------------------------------------------*/

void MaterialColorful::prepareMaterial(
		FrameInfo_t			*di,
		Geometry			*geometry
	)
{
	/* Not much to do here... */
}

/*---------------------------------------------------------------------------*/

Resource *MaterialColorful::clone(
		const char		*clone_name,

		u32				purge_level
	)
{
	MaterialColorful *new_res = (MaterialColorful *) sceneGraph.createMaterial(materialType,
		clone_name, purge_level);

	return new_res;
}

/*---------------------------------------------------------------------------*/

