/*
 * Textured Directionally lit material
 *
 * This uses the world position of the first light source in the Geometry it's
 * applied to, as the direction of the light source.
 */

#ifndef __RC_MATERIALDIRECTIONAL_H__
#define __RC_MATERIALDIRECTIONAL_H__

class MaterialDirectional : public Material {
	friend class SceneGraph;
	friend class Material;

/*----------------------------------------------------------[ Functions ]----*/

	private:
		MaterialDirectional(
				const char		*nidentifier,
				u32				purge_level
			);

		virtual ~MaterialDirectional();

	public:

		/* Diffuse texture */

		void setDiffuseTexture(
				Texture				*tex,

				bool				instantiate_resource
			);

		void setDiffuseTexture(
				const char			*filename,

				u32					purge_level
			);

		Texture *getDiffuseTexture();

		Resource *clone(
				const char			*clone_name,

				u32					purge_level
			);

	protected:
		void prepareMaterial(
				FrameInfo_t			*di,
				Geometry			*geometry
			);

/*------------------------------------------------------------[ Members ]----*/

	public:
		rgbf			ambient;
		rgbf			diffuse;
		rgbf			specular;
		f32				shininess;
		f32				emissive;
		f32				specularLevel;

	private:
		Texture			*diffuseTexture;

};


#endif /* __RC_MATERIALDIRECTIONAL_H__ */

