/* Textured point lit material */

#ifndef __RC_MATERIALPOINT_H__
#define __RC_MATERIALPOINT_H__

class MaterialPoint : public Material {
	friend class SceneGraph;
	friend class Material;

/*----------------------------------------------------------[ Functions ]----*/

	private:
		MaterialPoint(
				const char		*nidentifier,
				u32				purge_level
			);

		virtual ~MaterialPoint();

	public:

		/* Diffuse texture */

		void setDiffuseTexture(
				Texture				*tex,

				bool				instantiate_resource
			);

		void setDiffuseTexture(
				const char			*filename,

				u32					purge_level
			);

		Texture *getDiffuseTexture();

		Resource *clone(
				const char			*clone_name,

				u32					purge_level
			);

	protected:
		void prepareMaterial(
				FrameInfo_t			*di,
				Geometry			*geometry
			);

/*------------------------------------------------------------[ Members ]----*/

	public:
		rgbf			ambient;
		rgbf			diffuse;
		rgbf			specular;
		f32				shininess;
		f32				emissive;
		f32				specularLevel;

	private:
		Texture			*diffuseTexture;

};


#endif /* __RC_MATERIALPOINT_H__ */

