/* Simple, reflective material */

#ifndef __RC_MATERIALREFLECTIVE_H__
#define __RC_MATERIALREFLECTIVE_H__

class MaterialReflective : public Material {
	friend class SceneGraph;
	friend class Material;

/*----------------------------------------------------------[ Functions ]----*/

	private:
		MaterialReflective(
				const char		*nidentifier,
				u32				purge_level
			);

		virtual ~MaterialReflective();

	public:

		/* Cube map texture */

		void setCubeMap(
				CubeMap				*cube_map,

				bool				instantiate_resource
			);

		CubeMap *getCubeMap();

		Resource *clone(
				const char			*clone_name,

				u32					purge_level
			);

	protected:
		void prepareMaterial(
				FrameInfo_t			*di,
				Geometry			*geometry
			);

/*------------------------------------------------------------[ Members ]----*/

	private:
		CubeMap			*cubeMap;

};


#endif /* __RC_MATERIALREFLECTIVE_H__ */

