/* A weird material... */

#ifndef __RC_MATERIALWEIRD_H__
#define __RC_MATERIALWEIRD_H__

class MaterialWeird : public Material {
	friend class SceneGraph;
	friend class Material;

/*----------------------------------------------------------[ Functions ]----*/

	private:
		MaterialWeird(
				const char		*nidentifier,
				u32				purge_level
			);

		virtual ~MaterialWeird();

	public:

		/* Diffuse texture */

		void setDiffuseTexture(
				Texture				*tex,

				bool				instantiate_resource
			);

		void setDiffuseTexture(
				const char			*filename,

				u32					purge_level
			);

		Texture *getDiffuseTexture();

		void setNoiseTexture(
				Texture				*tex,

				bool				instantiate_resource
			);

		void setNoiseTexture(
				const char			*filename,

				u32					purge_level
			);

		Texture *getNoiseTexture();

		Resource *clone(
				const char			*clone_name,

				u32					purge_level
			);

	protected:
		void prepareMaterial(
				FrameInfo_t			*di,
				Geometry			*geometry
			);

/*------------------------------------------------------------[ Members ]----*/

	public:
		rgbf			ambient;
		rgbf			diffuse;
		rgbf			specular;
		f32				shininess;

	private:
		Texture			*diffuseTexture;
		Texture			*noiseTexture;

};


#endif /* __RC_MATERIALWEIRD_H__ */

