#ifndef __RC_SCENEGRAPHAUX_H__
#define __RC_SCENEGRAPHAUX_H__

/* Forward declarations */
class Node;
class World;
class State;
class Transformable;
class Group;
class Camera;
class Light;
class Geometry;
class TriangleMesh;
class Sprite;

class MatrixTransformation;

class ResourceList;
class Resource;
class Texture;
class CubeMap;
class Material;
class VertexArray;
class IndexArray;
class Shader;
class ShaderProgram;

typedef struct FrameInfo_t FrameInfo_t;


#include "Resource.h"
#include "ResourceList.h"

#include "Shader.h"
#include "ShaderProgram.h"
#include "VertexArray.h"
#include "IndexArray.h"
#include "Texture.h"
#include "CubeMap.h"
#include "Material.h"

#include "MatrixTransformation.h"

#include "Node.h"
#include "RenderState.h"
#include "State.h"

/* Contains draw info for each frame */
struct FrameInfo_t {

	MatrixTransformation	*matTransform;
	ShaderProgram			*activeShader;
	StateSettings_t			currentState;
	DeviceState_t			*deviceState;

};

#include "World.h"
#include "Transformable.h"
#include "Camera.h"
#include "Light.h"
#include "Group.h"
#include "Geometry.h"
#include "TriangleMesh.h"
#include "Sprite.h"

#include "Text.h"


#endif /* __RC_SCENEGRAPHAUX_H__ */

