#include <cstdio>
#include <cstring>

#include "RenderChimp.h"






static void testAddDelete()
{
	TriangleMesh *ship;

	sceneGraph.printDebugInfo();
	ship = (TriangleMesh *) sceneGraph.createTriangleMesh("Ship", "../models/ogrehead.pwn", true, 0);
//	logAllocations();

	sceneGraph.printDebugInfo();
	sceneGraph.deleteNode(ship);

	sceneGraph.printDebugInfo();

}

static void testDuplicate()
{
	u32 i;
	TriangleMesh *ship, *ref[25];

	ship = (TriangleMesh *) sceneGraph.createTriangleMesh("Ship", "../models/ogrehead.pwn", true, 0);

	for (i = 0; i < 25; i++) {
		char name[1024];
		sprintf(name, "duplication %d", i);
		ref[i] = (TriangleMesh *) ship->duplicate(name, false);
	}

	sceneGraph.printDebugInfo();

	sceneGraph.deleteNode(ship);

	for (i = 0; i < 25; i++) {
		sceneGraph.deleteNode(ref[i]);
	}

	sceneGraph.printDebugInfo();
}


static void testRepeatedReads()
{
	u32 i;
	TriangleMesh *ship, *ref[25];

	ship = (TriangleMesh *) sceneGraph.createTriangleMesh("Ship", "../models/ogrehead.pwn", false, 0);

	for (i = 0; i < 25; i++) {
		ref[i] = (TriangleMesh *) sceneGraph.createTriangleMesh("Ship", "../models/ogrehead.pwn", false, 0);
	}

	sceneGraph.printDebugInfo();

	sceneGraph.deleteNode(ship);

	for (i = 0; i < 25; i++) {
		sceneGraph.deleteNode(ref[i]);
	}

	sceneGraph.printDebugInfo();

}


static void testPurge()
{
	u32 i;
	TriangleMesh *ship, *ref[25];

	ship = (TriangleMesh *) sceneGraph.createTriangleMesh("Ship", "../models/ogrehead.pwn", false, 0);

	for (i = 0; i < 25; i++) {
		ref[i] = (TriangleMesh *) sceneGraph.createTriangleMesh("Ship", "../models/ogrehead.pwn", true, i);
	}

	sceneGraph.printDebugInfo();

	for (i = 0; i < 11; i++) {
		sceneGraph.deleteNode(ref[i]);
	}

	sceneGraph.purgeResources(10);

	sceneGraph.printDebugInfo();

	sceneGraph.deleteNode(ship);

	sceneGraph.printDebugInfo();

	for (i = 11; i < 25; i++) {
		sceneGraph.deleteNode(ref[i]);
	}

	sceneGraph.purgeResources(100);

	sceneGraph.printDebugInfo();

}




void RCInit()
{
	testAddDelete();
//	testDuplicate();
//	testRepeatedReads();
//	testPurge();
}


u32 RCUpdate(
		DeviceState_t *dstate
	)
{
	glClearColor(0.0f, 0.0f, 0.0f, 1.0f);
	glClear(GL_COLOR_BUFFER_BIT);
//	sceneGraph.text->print("~bT ~i e~b I s~i t i n g~c3579...", -0.9f, 0.8f, 250, 10);
	sceneGraph.text->print(" I ~i I", -0.9f, 0.8f, 250, 10);

	return 0;
}


void RCDestroy()
{
}



