#include <cstdio>
#include <cstring>

#include "RenderChimp.h"

World *world;
Camera *cam;
Group *cam_group;
Group *spaceship;
Light *light0;
TriangleMesh *mesh0;
TriangleMesh *mesh1;
MaterialPoint *mat;
//MaterialReflective *mat;
//MaterialDirectional *mat;

Sprite *sprite;

MaterialPoint *mp;

f32 move = 0.0f;

void RCInit()
{
	/* Create world */
	world = sceneGraph.createWorld("MyWorld");



	/* Create lights */
	light0 = sceneGraph.createLight("blue_light", rgbf(1.0f, 1.0f, 1.0f), 1.0f);
	light0->translate(100.0f, 100.0f, 100.0f);

	world->attachChild(light0);


	/* Loading spaceship sub-tree */
	//spaceship = sceneGraph.createGroup("../models/spaceship.pwn", true);
	//spaceship = sceneGraph.createGroup("apan", "../models/pteapot.pwn", false, 100);
	//spaceship = sceneGraph.createGroup("apan", "../models/spaceship.pwn", false, 100);
	//spaceship = sceneGraph.createGroup("apan", "../models/cannontower.pwn", false, 100);

	//mesh0 = (TriangleMesh *) spaceship->getChild(0);
	mesh0 = sceneGraph.createTriangleMesh("AAPasdf", "../models/ogrehead.pwn", false, 100);
	mesh0->scale(0.25f, 0.25f, 0.25f);

	mesh1 = (TriangleMesh *) mesh0->duplicate("Fisk", false);
	mesh1->scale(1.5f, 0.5f, 0.5f);

//	world->attachChild(spaceship);
	world->attachChild(mesh0);
	mesh0->attachChild(mesh1);


	mesh0->setLight(light0, 0);

	mesh1->setLight(light0, 0);

	mesh1->translate(30.0f, 0.0f, 0.0f);
	mesh0->translate(0.0f, 0.0f, 0.0f);


	/* Setup material */
	mat = (MaterialPoint *) sceneGraph.createMaterial(MATERIAL_POINT, "space_material", 0);
	mat->specular = rgbf(1.0f, 1.0f, 1.0f);
	mat->specularLevel = 1.0f;
	mat->shininess = 10.5f;
	mat->diffuse = rgbf(1.0f, 1.0f, 1.0f);
	mat->ambient = rgbf(0.0f, 0.0f, 0.0f);
	mat->emissive = 0.0f;
	mat->setDiffuseTexture("../textures/tiles.png", true);

	mesh0->setMaterial(mat, false);


	/*
	CubeMap *cm = sceneGraph.createCubeMap("cm",
		"../skyboxes/sb_left.png",
		"../skyboxes/sb_right.png",
		"../skyboxes/sb_up.png",
		"../skyboxes/sb_down.png",
		"../skyboxes/sb_front.png",
		"../skyboxes/sb_back.png",
		10000);

	mat->setCubeMap(cm, false);
*/
	/* Setup camera */
	cam_group = sceneGraph.createGroup("CamGroup");

	cam = sceneGraph.createCamera("MyCam");
	cam->setPerspectiveProjection(3.1415926534f * 0.25f, 320.0f / 480.0f, 6.25f, 980.0f);

	cam->translate(0.0f, 0.0f, 50.0f);

	world->attachChild(cam_group);

	cam_group->attachChild(cam);

	world->setActiveCamera(cam);



	/* Create sprite */
	sprite = sceneGraph.createSprite("MrSprite", "../textures/test.png", false);

	sprite->translate(0.0f, 0.0f, 80.0f);
	sprite->setSize(vec2f(5.0f, 2.0f));

	//sprite->setVisible(false);
	//sprite->setLight(light1, 0);

	mesh0->attachChild(sprite);



	/* Add texture */
	mp = (MaterialPoint *) mesh0->getMaterial();

	mp->setDiffuseTexture("../textures/tiles.png", true);

//	cam_group->setRotate(3.141592654f * 0.5f, 0.0f, 1.0f, 0.0f);
}

u32 RCUpdate(
		DeviceState_t *dstate
	)
{
	//cam_group->rotate(3.141592654f * sin(dstate->time), 1.0f, 0.0f, 0.0f);
	cam_group->setRotate(3.141592654f * dstate->x, 0.0f, 1.0f, 0.0f);
	cam_group->rotate(3.141592654f * dstate->y, 1.0f, 0.0f, 0.0f);

	/*
	if (dstate->touch) {
		vec4f dc = vec4f(dstate->x, dstate->y, -1.0, 1.0);

//		vec4f apa = world->hackmat * dc;

		apa /= apa.w;

		mesh0->setTranslate(apa.x, apa.y, apa.z);
	}
	*/

	mesh1->rotate(0.01f * dstate->timeStep, 1.0f, 1.0f, 1.0f);

	world->drawAll(dstate);

	return 0;
}

void RCDestroy()
{
	sceneGraph.deleteNode(world);
}

