attribute vec2 Vertex;

uniform vec2 Size;
uniform vec3 Position;

uniform vec2 TexcoordsFrom;
uniform vec2 TexcoordsTo;

uniform mat4 WorldViewProjection;
uniform mat4 View;
uniform mat4 Projection;

uniform mediump	vec3 LightColor;

uniform sampler2D TextureSampler;

varying mediump	vec2 texcoord;
varying mediump	vec3 color;

void main() {

	color = LightColor;

	vec4 wvpos = View * vec4(Position, 1.0);
	vec4 offset = vec4((Vertex * Size), 0.0, 0.0);
	
	vec2 wgt = (Vertex + 1.0) * 0.5;
	
	texcoord = wgt * (TexcoordsFrom - TexcoordsTo) + TexcoordsTo;
	
	gl_Position = Projection * (wvpos + offset);

}

